
--Major chunks of XML only

-- There only appears to be one input_relation, calculator, and stats_collection per-document
WITH xEvents AS
(SELECT object_name AS xEventName,
CAST (event_data AS xml) AS xEventData
FROM sys.fn_xe_file_target_read_file
('T:\traces\cardinality*.xel', NULL, NULL, NULL)), -- XEvent session should have file target, change to represent your location
cEvents AS
(SELECT xEventData.value('(/event/action[@name="sql_text"]/value)[1]','varchar(max)') SQLStatement,
xEventData.value('(/event/data[@name="stats_collection_id"]/value)[1]','bigint') StatsCollectionID,
xEventData.query('(/event/data[@name="input_relation"]/value/*)[1]') InputRelation,
xEventData.query('(/event/data[@name="calculator"]/value/*)[1]') Calculator,
xEventData.query('(/event/data[@name="stats_collection"]/value/*)[1]') StatsCollection,
xEventData as EntireEvent
FROM xEvents
)
-- local-name requires singleton or empty sequence
select *
from cEvents
--where cast(Calculator as nvarchar(1000)) like '%Exponential%'
GO