
-- http://blogs.msdn.com/b/ialonso/archive/2012/04/16/how-the-query-execution-engine-calculates-the-threshold-it-uses-to-detect-inaccurate-cardinality-estimation-and-fire-the-inaccurate-cardinality-estimate-extended-event.aspx
use pubs
go

if object_id ('dbo.cardTable') is not null
drop table dbo.cardTable
go

create table dbo.cardTable (c1 int)
go

set nocount on
begin tran
declare @i int = 0
while @i < 10000
begin
if (@i < 10)
begin
insert into cardTable values (-1)
end
if (@i < 8)
begin
insert into cardTable values (-2)
end
insert into cardTable values (@i)
insert into cardTable values (@i)
set @i = @i + 1
end
commit tran
create index ix_C1 on dbo.cardTable (c1)
go

if object_id ('dbo.p_test') is not null
drop procedure dbo.p_test
go
create procedure dbo.p_test @i int
as
select * from dbo.cardTable where c1 = @i
go

--Run the following:
set statistics profile on
exec dbo.p_test 1
go
exec dbo.p_test -1
go
exec dbo.p_test -2
insert into cardTable values (-2)
go 100

--run again, the actual_rows value has got nothing to do with the actual number of rows shown in the plan:
set statistics profile on
exec dbo.p_test 2
